;**************************************************
; * Project Name: Shaders
; * Author(s): L.D.M.T.  (aka Mixei)
; * Date Started: 10.1.2009
; * myblitz3d.narod.ru
; * E-mail:myblitz3d@yandex.ru
;**************************************************


Graphics3D 640,480,32,2

Dim posx#(20),posy#(20)

POSY(2)=2
POSX(2)=2

AmbientLight 150,150,170
SetBuffer BackBuffer()

SeedRnd MilliSecs()

camera=CreateCamera()
PositionEntity camera,0,25,30

light=CreateLight(2) ; create light


Center=CreatePivot()
PointEntity camera,Center

PositionEntity light,50,80,0
Lsphere=CreateSphere(4,light) 
EntityFX Lsphere,1

tex1=LoadTexture("wall_00.jpg")
ScaleTexture tex1,.3,.3
;tex2=LoadTexture("wood_panel_00.jpg")
;TextureBlend TEX1,5

tex2=LoadTexture("Eklylla.JPG",4)

tex8=LoadTexture("Eklylla.JPG",4)

tex3=LoadTexture("$hiny.jpg",64+256)

tex4=LoadTexture("gr_wf5.jpg",4)

ScaleTexture TEX4,.2,.2

Cyl=CreateSphere(12) 
PositionEntity Cyl,-25,10,-25
ScaleEntity Cyl,8,8,8
EntityTexture Cyl,tex8
;EntityTexture Cyl,tex8,0,2


Cyl2=CreateSphere(12) 
PositionEntity Cyl2,25,10,-25
ScaleEntity Cyl2,8,8,8
EntityTexture Cyl2,tex2
EntityTexture Cyl2,tex4,0,2

Cylinder=CreateCylinder(12) 
PositionEntity Cylinder,0,10,0
ScaleEntity Cylinder,5,15,5
RotateEntity Cylinder,90,0,0
EntityTexture Cylinder,tex2
EntityTexture Cylinder,tex3,0,2
EntityTexture Cylinder,tex4,0,3

cube=CreateCube()
ScaleEntity cube,50,2,50
EntityTexture cube,tex1
EntityTexture cube,tex4,0,2
MoveMouse GraphicsWidth()/2,GraphicsHeight()/2


While Not KeyHit(1)

TurnEntity Cylinder,0,0,1
RenderWorld(camera)
mysetshader3(tex2)
mysetshader6(tex4)
;mysetshader4(tex8)
Flip 1
Wend
End


Function mysetshader2(tex3)


xx=TextureWidth(tex3)
yy= TextureHeight(tex3)

LockBuffer TextureBuffer(tex3)

For RAZ=1 To 500

X=Rnd(0,XX)
Y=Rnd(0,YY)

WritePixel x,y,RGB(255,255,255),TextureBuffer(tex3)
Next

UnlockBuffer TextureBuffer(tex3)
End Function


Function mysetshader3(tex3)

xx=TextureWidth(tex3)
yy= TextureHeight(tex3)

LockBuffer TextureBuffer(tex3)

For RAZ1=POSX(1) To POSX(2)

POSX(2)=POSX(2)+.05
If POSX(2)>XX POSX(2)=XX

If POSX(2)>XX POSX(2)=XX

For RAZ2=POSY(1) To POSY(2)

POSY(2)=POSY(2)+.05
If POSY(2)>YY POSY(2)=YY

X=RAZ1 Or Rnd(0,1)
Y=RAZ2 Or Rnd(0,1)

WritePixel x,y,RGB(255,255,255),TextureBuffer(tex3)
Next
;POSX(2)=2

Next

UnlockBuffer TextureBuffer(tex3)
End Function


Function mysetshader4(tex3)

xx=TextureWidth(tex3)
yy= TextureHeight(tex3)

LockBuffer TextureBuffer(tex3)

For RAZ=1 To 5000
X=Rnd(0,XX)
Y=Rnd(0,YY)

argb=ReadPixel(x,y,TextureBuffer(tex3))
r=((ARGB Shr 16) And $ff) + (Rnd(8))
g=((ARGB Shr 8) And $ff) + (Rnd(8))
b=(ARGB And $ff) + (Rnd(8))
If R> 255 R=255
If G> 255 G=255
If B> 255 B=255

WritePixel x,y,RGB(R,G,B),TextureBuffer(tex3)
Next

UnlockBuffer TextureBuffer(tex3)
End Function


Function mysetshadeR5(tex3)



xx=TextureWidth(tex3)
yy= TextureHeight(tex3)

LockBuffer TextureBuffer(tex3)

For RAZ=1 To 10000
X=Rnd(0,XX)
Y=Rnd(0,YY)

argb=ReadPixel(x,y,TextureBuffer(tex3))
r=((ARGB Shr 16) And $ff)+5
g=((ARGB Shr 8) And $ff) +5
b=(ARGB And $ff) +5

If R> 255 R=255
If G> 255 G=255
If B> 255 B=255

X=Rnd(0,XX)
Y=Rnd(0,YY)

WritePixel x,y,RGB(R,G,B),TextureBuffer(tex3)

Next

UnlockBuffer TextureBuffer(tex3)
End Function


Function mysetshadeR6(tex3)


xx=TextureWidth(tex3)
yy= TextureHeight(tex3)

If posx(4)>xx And posy(4)>yy Return 

LockBuffer TextureBuffer(tex3)
er=0
posx(4)=posx(4)+1
posy(4)=posy(4)+1

If posy(4)>yy posy(4)=yy
If posx(4)>xx posx(4)=xx

;For er=1 To 2
er=2
For RAZ1=0 To posx(4)

For RAZ2=0 To posy(4)

x=raz1
y=raz2

argb=ReadPixel(x,y,TextureBuffer(tex3))
r=((ARGB Shr 16) And $ff)+er
g=((ARGB Shr 8) And $ff) +er
b=(ARGB And $ff) +er

If R> 255 R=255
If G> 255 G=255
If B> 255 B=255

WritePixel x,y,RGB(r,g,b),TextureBuffer(tex3)
WritePixel xx-raz1,yy-raz2,RGB(r,g,b),TextureBuffer(tex3)
Next

Next
;Next
UnlockBuffer TextureBuffer(tex3)
End Function



Function RGB(r,g,b)
;argb=(b Or (g Shl 8) Or (r Shl 16) Or ($FF0000000))
argb=(b Or (g Shl 8) Or (r Shl 16) )
Return argb;'(r Shl 16) Or (g Shl 8) Or b Or (0 Shl 24)
End Function
